#ifndef __HAPLOID_H__
#define __HAPLOID_H__

#include <stdio.h>
#include <stdlib.h>
#include <iostream>

#include "fp.h"
#include "indiv.h"
#include "model.h"

using namespace std;

class HapInd : public Individual
{
private:
	double ** m_phi; 						// forward MxK
	double ** m_psi; 					// backward MxK

	vector<vector<double > > vvfwdp; 
	vector<vector<double > > vvfwd; 
	vector<vector<double > > vvbwd; 
public:
	HapInd();
	HapInd(int);
    ~HapInd();
	
	double prG(double, short); 
	double get_snpmgt(int m) {if(m_mgt) return m_mgt[m]; else if(snp_dstr) return snp_dstr[2*m+1]; else return (double) (snpGT[m]-'0'); }; 
	void get_snp_dstr(int m, double * r) { r[0] = snp_dstr[2*m];r[1] = snp_dstr[2*m+1];}
	void allocate_snp_mgt(int n) {m_mgt = (double *) Allocate1D(sizeof(double),  n); }
	void allocate_snp_dstr(int n) {snp_dstr = (double *) Allocate1D(sizeof(double),  n * 2); }

	virtual void CalcAll(const int, const int, class ModelParam *, double **, double **, double **, double **, int, int);

	virtual void compute_mgt(const int, const int, ModelParam *,int, int);
	virtual void compute_snp_dstr(const int, const int, ModelParam *, int);
	virtual void compute_ps(const int, const int, ModelParam *, const int);
	virtual void compute_ps(const int, const int, ModelParam * pMD, const int, const int, vector<int>);
	virtual void compute_pk(const int, const int, ModelParam *, const int);
	virtual void compute_pk(const int, const int, ModelParam * pMD, const int, const int, vector<int>);
	virtual void clean_after_em(int); 
	virtual void forward_backward_block(const int, const int, class ModelParam *, double **, double **, double **, double **, int, int, vector<int>);	
};

#endif 
